/**
 * @function _bud
 */
"use strict";

const path = require('path'),
    pkg = require('../package.json');

/** @lends _bud */
function _bud(tmpl, src, dest, params) {
    let basename = path.basename(src, path.extname(src)),
        filename = path.resolve(dest, basename + '_test.js');
    return {
        force: false,
        mode: '644',
        mkdirp: false,
        path: filename,
        tmpl: tmpl,
        data: {
            params: params,
            name: basename,
            relative: path.relative(dest, src),
            file: path.basename(filename),
            generator: 'coz',
            today: new Date().toLocaleDateString(),
            pkg: pkg
        }
    }
}

module.exports = _bud;
