/**
 * apeman bud for test files.
 * @memberof module:apeman-bud-test/lib
 * @function setup
 * @param {object} params - Template params.
 * @returns {object} - Coz bud configuration.
 */

"use strict";

const argx = require('argx'),
    assert = require('assert'),
    expandglob = require('expandglob'),
    path = require('path'),
    arrayfilter = require('arrayfilter'),
    _tmpl = require('./_tmpl'),
    _bud = require('./_bud'),
    _isModule = require('./_is_module');

/** @lends setup */
function setup(params) {
    let args = argx(arguments);
    params = args.shift('object');
    let src = params.src,
        dest = params.dest || process.cwd();

    assert(params.type, "params.type is required.");
    assert(params.src, "params.src is required.");

    let tmpl = _tmpl(params.type);
    return expandglob.sync(src)
        .sort((a, b) => a.length - b.length)
        .filter(arrayfilter.patternReject(/^[\._\-]/))
        .filter(arrayfilter.patternReject(/index\.js$/))
        .filter(_isModule)
        .map((src) => {
            return _bud(tmpl, src, dest, params);
        });
}

module.exports = setup;
